	include	"tios.h"

	include	"userlib.h"
	include	"filelib.h"
	include	"graphlib.h"
	include	"ziplib.h"
	include	"jrdlib.h"
	include	"my_macros.h"
	xdef	_main
	xdef	_comment
	xdef	_exit
	xdef	_ti89
	xdef	_ti92plus

;Format des arguments:
;	ZipFile(pathname,method,msg)
;
;	If none of the arguments are present or if they don't have the good format,
;	a dialog box will appear to enter the name of the file. ( Not a local file ! )
;
;	pathname can be a filename with a folder (string)
;		or a filename alone with a char(159) in front of
;		showing that it is a local file.
;	method can take these values : 0,1 or 2 :			Facultatif
;		0 : Zip/Unzip (Automatic).			BY DEFAULT
;		1 : Zip.
;		2 : Unzip.
;	msg can take these values : 0,1 ou 2 :			Facultatif
;		0 : no message.
;		1 : only error messages.			BY DEFAULT
;		2 : all messages.


;**********************************************

init:
	movem.l	a0/d0,-(a7)
	lea	urep,a0
	move.w	#8,d0
\loopinit1:
	move.b	#0,(a0)+
	dbra	d0,\loopinit1
	lea	ufile,a0
	move.w	#8,d0
\loopinit2:
	move.b	#0,(a0)+
	dbra	d0,\loopinit2
	movem.l	(a7)+,a0/d0
	rts

;**********************************************
; a5 doit pointer au dbut d'un arg de la estack.
;find_nextintarg:
;	cmp.b	#$E5,-(a5)
;	beq	\fin_arg
;	cmp.b	#$1F,(a5)
;	bne	find_nextintarg
;\fin_arg:
;	rts
; a5 pointe l'arg entier suivant ou la fin des args.


;**********************************************
;moins1:
;	cmp.b	#0,(a5)
;	beq	\fin_moins1
;	sub.w	#1,a5
;\fin_moins1:
;	rts

;**********************************************

_main:
	bsr	init
	movem.l	d0-d7/a0-a6,-(a7)
	jsr	jrdlib::InitArgs
	lea	argstr,a0
	jsr	jrdlib::GetStringArg
	cmp.b	#1,d0
	beq	Normal
	jsr	jrdlib::GetStringLong
	move.w	d1,d6		; d6 contient le nombre de car
; a0 pointe sur le dbut de la chane.
	cmp.b	#$3F,(a0)		; '?'
	beq	aide
	move.l	a0,a1
	add.w	d6,a1		; a1 pointe sur la fin de la chane (le 0).
	move.w	#0,d0
	lea	NoFolder,a6
\loopfile:
	add.w	#1,d0
	sub.w	#1,a1
	cmp.b	#$5C,(a1)		; '\'
	beq	arg_folder_exist
	cmp.b	#$9F,(a1)		; 'angle' ( /_ )
	beq	arg_folder_local
	cmp.b	#0,(a1)
	beq	arg_folder_notexist
	cmp.w	#18,d0
	bls	\loopfile
	bra	Normal

arg_folder_exist:
	add.w	#1,a1
	lea	ufile,a2
\loop1:
	move.b	(a1)+,(a2)+
	cmp.b	#0,(a1)
	bne	\loop1
	move.b	#0,(a2)		; obtient le nom de la variable.
	lea	urep,a2
\loop2:
	move.b	(a0)+,(a2)+
	cmp.b	#$5C,(a0)
	bne	\loop2
	move.b	#0,(a2)		; obtient le rpertoire de la variable.
	move.l	#1,d7		; ???
	bra	getdir

arg_folder_local:
	lea	LocalVar,a6
arg_folder_notexist:
	add.w	#1,a1
	lea	ufile,a2
\loop1:
	move.b	(a1)+,(a2)+
	cmp.b	#0,(a1)
	bne	\loop1
	move.b	#0,(a2)		; obtient le nom de la variable.
	jmp	(a6)		; saute  NoFolder ou  LocalVar

; -----------------------------------------------------------
LocalVar:
	lea	ufile,a0
	jsr	jrdlib::Find_Local
	cmp.l	#0,a0
	beq	var_notfound
	move.w	#8,handle_folder_var
	move.w	d0,index_var
	move.b	10(a0),arch_state
	bra	prezip
; -----------------------------------------------------------
NoFolder:
	lea	ufile,a0
	jsr	jrdlib::Find_No_Local
	cmp.w	#0,a0
	beq	var_notfound
	move.w	#8,handle_folder_var
	move.w	d0,index_var
	move.b	10(a0),arch_state
	bra	prezip
; -----------------------------------------------------------
Normal:	
	move.l	#0,d7
	move.w	#10,d0
	move.w	#20,d1
	move.w	#140,d2
	move.w	#60,d3
	lea	_comment,a0
	jsr	graphlib::box
	SetFont	#1
	WriteStr	#15,#40,#4,rep
	WriteStr	#15,#50,#4,file
	SetFont	#0
	WriteStr	#15,#70,#4,to_read
	pea	help
	jsr	tios::ST_showHelp
	lea	4(a7),a7
inp_folder:
	rempli	#75,#48,#56,#10,#1
	lea	urep,a0
	lea	inp_file,a1
	lea	_exit,a2
	move.w	#75,d1
	move.w	#40,d2
	move.l	#8,d3
	jsr	jrdlib::Input
	jmp	(a1)
inp_file:
	lea	ufile,a0
	lea	getdir,a1
	lea	inp_folder,a2
	move.w	#70,d1
	move.w	#50,d2
	move.l	#8,d3
	jsr	jrdlib::Input
	jmp	(a1)
getdir:
	pea	urep
	move.w	#8,-(a7)	
	jsr	jrdlib::FindEntry
	lea	6(a7),a7
	cmp.w	#0,a0
	beq	fold_notfound
	add.w	#12,a0
; a0 pointe le handle de la table des fichiers du rpertoire.

getfile:
	move.w	(a0),handle_folder_var
	pea	ufile
	move.w	(a0),-(a7)	
	jsr	jrdlib::FindEntry
	lea	6(a7),a7
	cmp.w	#0,a0
	beq	var_notfound
	move.w	d0,index_var
; a0 pointe la structure du fichier dans la VAT.
	move.b	10(a0),arch_state
	cmp.l	#0,d7
	bne	prezip
zip_fichier:
	move.b	#2,(msgz)
	bra	zip

prezip:
	jsr	jrdlib::NextArg
	cmp.b	#1,d0
	beq	\s2		; si plus d'arg alors par dfaut c'est 0 et 1.
	move.b	#1,d0
	jsr	jrdlib::GetIntArg
	cmp.b	#0,d0
	bne	Normal		; si pas un entier ou si >255...
	move.b	d1,(cmd)
	jsr	jrdlib::NextArg
	cmp.b	#1,d0
	beq	\s1		; si plus d'arg alors par dfaut c'est 1.
	move.b	#1,d0
	jsr	jrdlib::GetIntArg
	cmp.b	#0,d0
	bne	Normal		; si pas un entier ou si >255...
	move.b	d1,(msgz)
	bra	\s3
\s1:
	move.b	#1,(msgz)
	bra	\s3
\s2:
	move.b	#1,(msgz)
	bra	zip
\s3:
	cmp.b	#1,(cmd)
	beq	cmd_zip
	cmp.b	#2,(cmd)
	beq	cmd_unzip
	bra	zip
cmd_zip:
	jsr	ziplib::iscomp
	cmp.w	#0,d0
	bne	zip	
	bra	_exit
cmd_unzip:
	jsr	ziplib::iscomp
	cmp.w	#0,d0
	beq	zip	
	bra	_exit
zip:
	move.b	(msgz),d0
	jsr	ziplib::zipfile
	bra	pre_exit

fold_notfound:
	move.w	#420,-(a7)
	bra	error
var_notfound:
	move.w	#960,-(a7)
	bra	error
too_few_arg:
	move.w	#930,-(a7)
	bra	error
error:
	jsr	tios::ERD_dialog
	lea	2(a7),a7
	bra	_exit
aide:
	pea	help
	jsr	tios::ST_showHelp
	lea	4(a7),a7
	jsr	userlib::idle_loop
	bra	_exit
pre_exit:
	cmp.b	#2,arch_state
	bne	_exit
	move.b	10(a0),d0
	cmp.b	#2,d0
	beq	_exit
	move.w	handle_folder_var,d0
	move.w	index_var,d1
	jsr	filelib::archive	
_exit:
	movem.l	(a7)+,d0-d7/a0-a6
	rts

; Variables
_comment:	dc.b	"ZipFile v1.5 by JRD",0
help		dc.b	"zipfile(string-file,method,message)",0
argstr		dcb.b	18,0	; 8 + 1(\) + 8 + 1(0)
rep		dc.b	"Folder :",0
file		dc.b	"File :",0
to_read		dc.b	"P.S. : '",159,"' before, for a local file",0
urep		dc.b	"        ",0
ufile		dc.b	"        ",0
arch_state	dc.b	0
handle_folder_var	dc.w	0
index_var		dc.w	0
cmd		dc.b	0
msgz		dc.b	0

	END